//
// DSP.H
//

#ifndef __DSP_H__
#define __DSP_H__

#include "jaguar.h"

//HCF, to quit sums in heavily used methods
#define DSP_CONTROL_RAM_BASE_END 0x00F1A120
#define DSP_CONTROL_RAM_BASE     0x00F1A100

//HCF, to quit sums in heavily used methods
#define DSP_WORK_RAM_BASE_END   0x00F1CFFF
#define DSP_WORK_RAM_BASE		0x00F1B000



void xbox_free_dsp(void);

void DSPInit(void);
void DSPReset(void);
void DSPExec(int32);
void DSPDone(void);
//HCF 2013: Static!
static void DSPUpdateRegisterBanks(void);
//HCF 2013: Static!
static void DSPHandleIRQs(void);
void DSPSetIRQLine(int irqline, int state);
//HCF: Quit the unusefull parameters
uint8 DSPReadByte(uint32 offset);
uint8 DSPReadByteControl(uint32 offset);
uint8 DSPReadByteWork(uint32 offset);
//uint8 DSPReadByte(uint32 offset, uint32 who = UNKNOWN);
//HCF: Quit the unusefull parameters
uint16 DSPReadWord(uint32 offset);
uint16 DSPReadWordControl(uint32 offset);
uint16 DSPReadWordWork(uint32 offset);
//uint16 DSPReadWord(uint32 offset, uint32 who = UNKNOWN);

//HCF: Quit the unusefull parameters
//HCF 2013: Static!
static uint32 DSPReadLong(uint32 offset);
static uint32 DSPReadLongControl(uint32 offset);
//uint32 DSPReadLong(uint32 offset, uint32 who = UNKNOWN);
//HCF: Quit the unusefull parameters
void DSPWriteByte(uint32 offset, uint8 data);
void DSPWriteByteControl(uint32 offset, uint8 data);
void DSPWriteByteWork(uint32 offset, uint8 data);
//void DSPWriteByte(uint32 offset, uint8 data, uint32 who = UNKNOWN);
//HCF: Quit the unusefull parameters
void DSPWriteWord(uint32 offset, uint16 data);
void DSPWriteWordControl(uint32 offset, uint16 data);
void DSPWriteWordWork(uint32 offset, uint16 data);
//void DSPWriteWord(uint32 offset, uint16 data, uint32 who = UNKNOWN);
//HCF: Quit unusefull parameters
//HCF 2013: Static!
static void DSPWriteLong(uint32 offset, uint32 data);
//void DSPWriteLong(uint32 offset, uint32 data, uint32 who = UNKNOWN);
//HCF Unusefull
//void dsp_releaseTimeslice(void);

// DSP interrupt numbers (in $F1A100, bits 4-8 & 16)

enum { DSPIRQ_CPU = 0, DSPIRQ_SSI, DSPIRQ_TIMER0, DSPIRQ_TIMER1, DSPIRQ_EXT0, DSPIRQ_EXT1 };

#endif	// __DSP_H__
