#ifndef VIDXBOX_H
#define VIDXBOX_H

#define D3DFVF_CUSTOMVERTEX (D3DFVF_XYZ /*| D3DFVF_DIFFUSE*/ |D3DFVF_TEX1)
#define TEXWIDTH 512
#define TEXHEIGHT 256

#include <xtl.h>
#include <xgraphics.h>
#define XFONT_TRUETYPE
#include <xfont.h>

#include "types.h"

//HCF to store the video mode
#define FILE_VIDEO "D:\\video.ini"
#define MODO_VIDEO_480 0
#define MODO_VIDEO_720 1
#define MODO_VIDEO_1080 2

typedef unsigned __int8		byte;
typedef unsigned __int16	word;

//HCF Already defined in types.h
//typedef unsigned __int32	dword;

typedef unsigned __int64	qword;

typedef struct CustomVertex
{
    float x, y, z;
    //dword color;
	float u, v;
}CustomVertex;

class VIDXBOX
{
public:
	VIDXBOX(void);
	~VIDXBOX(void);

	bool Create();
	bool CreateVertexBuffer(dword dwLength);
	bool CreateTexture(dword dwWidth, dword dwHeight);

	void BeginRender();
	void EndRender();

	HRESULT CreatePixelShaderFromFile(const char* strFilename, DWORD* pdwPixelShader);

	void RenderToTexture(unsigned char *buffer);

	XFONT *g_defaultTrueTypeFont;

public:
	Direct3D		*m_pD3D; //D3D object
	D3DDevice		*m_pD3DDevice; //D3D device
	D3DVertexBuffer *m_pVertexBuffer; //D3D vertex buffer
	D3DTexture		*m_pTexture;//texture
	///D3DSurface		*m_pSurface;//surface
	DWORD			dwPixelShader;	//Pixel Shader


	DWORD m_dwWidth;
	DWORD m_dwHeight;
	float fWidth;
	float fHeight;

	D3DXMATRIX mat;

private:
};

extern VIDXBOX g_vidxbox;

extern int vdp2width;
extern int vdp2height;

//extern unsigned char * backbufferDX;
extern int * backbufferDX;

#endif

