//
// GPU.H: Header file
//

#ifndef __GPU_H__
#define __GPU_H__

#include "jaguar.h"

#define GPU_CONTROL_RAM_BASE_END  0x00F02120    //+0x20
#define GPU_CONTROL_RAM_BASE      0x00F02100

#define GPU_WORK_RAM_BASE_END    0x00F04000 //+0x1000
#define GPU_WORK_RAM_BASE		 0x00F03000

void xbox_free_gpu(void);

void gpu_init(void);
void gpu_reset(void);
void gpu_exec(int32);
void gpu_done(void);
void gpu_update_register_banks(void);
void GPUHandleIRQs(void);
void GPUSetIRQLine(int irqline, int state);

//HCF: Quit unusefull parameters
uint8 GPUReadByte(uint32 offset);
uint8 GPUReadByteControl(uint32 offset);
uint8 GPUReadByteWork(uint32 offset);
//uint8 GPUReadByte(uint32 offset, uint32 who = UNKNOWN);

//HCF: Quit unusefull parameters
uint16 GPUReadWord(uint32 offset);
uint16 GPUReadWordControl(uint32 offset);
uint16 GPUReadWordWork(uint32 offset);
//uint16 GPUReadWord(uint32 offset, uint32 who = UNKNOWN);

//HCF: Quit unusefull parameters
uint32 GPUReadLong(uint32 offset);
//uint32 GPUReadLong(uint32 offset, uint32 who = UNKNOWN);

//HCF: Quit unusefull parameters
void GPUWriteByte(uint32 offset, uint8 data);
void GPUWriteByteControl(uint32 offset, uint8 data);
void GPUWriteByteWork(uint32 offset, uint8 data);
//void GPUWriteByte(uint32 offset, uint8 data, uint32 who = UNKNOWN);

//HCF: Quit unusefull parameters
void GPUWriteWord(uint32 offset, uint16 data);
//void GPUWriteWord(uint32 offset, uint16 data, uint32 who = UNKNOWN);

//HCF: Quit unusefull parameters
void GPUWriteLong(uint32 offset, uint32 data);
//void GPUWriteLong(uint32 offset, uint32 data, uint32 who = UNKNOWN);

uint32 gpu_get_pc(void);
//HCF This is unusefull
//void gpu_releaseTimeslice(void);
//HCF 2013
//void gpu_reset_stats(void);
uint32 gpu_read_pc(void);

// GPU interrupt numbers (from $F00100, bits 4-8)

enum { GPUIRQ_CPU = 0, GPUIRQ_DSP, GPUIRQ_TIMER, GPUIRQ_OBJECT, GPUIRQ_BLITTER };

#endif	// __GPU_H__
