#ifndef _INPUT_XBOX_H__DASH_
#define _INPUT_XBOX_H__DASH_

#if _MSC_VER > 1000
#pragma once
#endif //_MSC_VER > 1000

#include "Input.h"

#include "types.h"
/*
typedef unsigned long DWORD;
typedef DWORD dword;
*/

#define XBINPUT_DEADZONE 0.24f
#define XBINPUT_PRESS_BUTTON_DELAY 5
#define XBINPUT_PRESS_TRIGGER_DELAY 100

typedef struct XBGAMEPAD  // : public XINPUT_GAMEPAD
{

	//HCF Not inherited anymore
	XINPUT_GAMEPAD hcfPad;

    // thumb stick values converted to range [-1,+1]
    float fX1;
    float fY1;
    float fX2;
    float fY2;
    
    // state of buttons tracked since last poll
    //word wLastButtons;
	unsigned short wLastButtons;
    bool bLastAnalogButtons[8];
	//word wPressedButtons;
	unsigned short wPressedButtons;
    bool bPressedAnalogButtons[8];

    // rumble properties
    XINPUT_RUMBLE Rumble;
    XINPUT_FEEDBACK Feedback;

    // device properties
    XINPUT_CAPABILITIES caps;
    HANDLE hDevice;

    // flags for whether game pad was just inserted or removed
    bool bInserted;
    bool bRemoved;
}XBGAMEPAD;


/*
class CInput
{
public:
*/
	void g_input_CInput();
//	~CInput();
	extern "C" bool g_input_Create();
	extern "C" void g_input_Update();
	bool g_input_IsLoaded();

	bool g_input_IsButtonPressed(void);
	//bool IsButtonPressed(eGenericButton button);
	extern "C" bool g_input_IsButtonPressed(int button);
	
	extern "C" byte g_input_IsLTriggerPressed();
	extern "C" byte g_input_IsRTriggerPressed();
	
	float g_input_GetThumbLX();
	float g_input_GetThumbLY();
	float g_input_GetThumbRX();
	float g_input_GetThumbRY();

	DWORD g_input_GetButtonDelay();
	void g_input_SetButtonDelay(DWORD milliseconds);

	DWORD g_input_GetTriggerDelay();
	void g_input_SetTriggerDelay(DWORD milliseconds);

	void g_input_RefreshDevices();

	extern XINPUT_POLLING_PARAMETERS m_pollingParameters;
	extern XINPUT_STATE m_inputStates[4];
	extern "C" XBGAMEPAD m_gamepads[4];
	extern bool m_buttonPressed;
	
	/*
	//temp - mouse stuff for win32
	//we can leave this here, as xbox mouse cursor is disabled
	//and mousestates are not being processed
	bool IsMouseOver(int x1pos, int y1pos, int x2pos, int y2pos);
	bool IsMousePress(Uint8 button);
	bool IsMouseClick(Uint8 button);

	#ifdef WITH_MOUSE //WIN32 only
	int GetMouseX();
	int GetMouseY();

	Sint16 MOUSESTATE;
	int x, y;//Mouse
	#endif

	Sint16 ABUTTON, BBUTTON, XBUTTON,  YBUTTON, WHITEBUTTON, BLACKBUTTON;
	Sint16 RTRIGGER, LTRIGGER, STARTBUTTON, BACKBUTTON;
	Sint16 RSTICK, LSTICK;//thumbsticks
	Sint16 JOYX, JOYY; //axes
	Sint16 RJOYX, RJOYY;//sticks
	Sint16 DPAD;//dpad
	Sint16 THRESHOLD;// = 18000 deadzone
	Uint8 *KEYS;//keyboard
	*/

//private:

	
	extern bool m_bLoaded;
	
//};

//extern CInput g_input;

#endif //_INPUT_XBOX_H__DASH_